[leetcode] 292. Nim Game 解题报告

题目链接:https://leetcode.com/problems/nim-game/

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

Hint:

  1. If there are 5 stones in the heap, could you figure out a way to remove the stones such that you will always be the winner?

思路:一道博弈论的题目。题意是两人交替从石头堆里取石子,一次可以取1-3个,谁最后拿完谁赢。有以下情况:

n = 1: 先拿的必胜

n = 2: 先拿的必胜

n = 3: 先拿的必胜

n = 4: 先拿的必败

n = 5: 可以先手拿一个,让对手面临n=4的状况,所以先手必胜

n = 6: 先手拿2个,让对手面临n = 4的状况,所以先手必胜

n = 7: 先手拿3个,让对手面临n = 4的状况,所以先手必胜

n = 8: 先手不管拿几个,对手都会让你陷入n = 4的状况,因此先手必败。

....

可知当n为4的倍数时,先手是必败的。也就是说你如果想要赢,你要做的就是把剩余的石子数变为4的倍数。

唔!终于把easy题做完了!到达124了,现在题目总共306道,阶段性任务已经完成,还有很长的路要走。奋斗

代码如下:

class Solution {
public:
    bool canWinNim(int n) {
        if(n % 4 == 0) return false;
        else return true;
    }
};
参考:http://blog.csdn.net/ironyoung/article/details/49100457

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 1
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值